Subject: Re: [PATCH v6 02/21] arm64: Allow mismatched 32-bit EL0 support

From: Catalin Marinas <[email-masked]>
Date: Mon, 24 May 2021 14:46:02 +0100

On Mon, May 24, 2021 at 01:09:59PM +0100, Will Deacon wrote:
> On Fri, May 21, 2021 at 11:41:56AM +0100, Catalin Marinas wrote:
> > On Tue, May 18, 2021 at 10:47:06AM +0100, Will Deacon wrote:
> > > +static int enable_mismatched_32bit_el0(unsigned int cpu)
> > > +{
> > > +	struct cpuinfo_arm64 *info = &per_cpu(cpu_data, cpu);
> > > +	bool cpu_32bit = id_aa64pfr0_32bit_el0(info->reg_id_aa64pfr0);
> > > +
> > > +	if (cpu_32bit) {
> > > +		cpumask_set_cpu(cpu, cpu_32bit_el0_mask);
> > > +		static_branch_enable_cpuslocked(&arm64_mismatched_32bit_el0);
> > 
> > It may be worth only calling static_branch_enable_cpuslocked() if not
> > already set, in case you try this on a system with lots of CPUs.
> 
> static_key_enable_cpuslocked() already checks this early on, so I don't
> think we need another check here (note that we're not calling stop_machine()
> here _anyway_; the '_cpuslocked' suffix just says that we're already holding
> cpu_hotplug_lock via the notifier).

Ah, you are right, no need for an additional check.

-- 
Catalin

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel